/*
 * JBoss, Home of Professional Open Source
 * Copyright 2013, Red Hat, Inc. and individual contributors
 * by the @authors tag. See the copyright.txt in the distribution for a
 * full listing of individual contributors.
 *
 * This is free software; you can redistribute it and/or modify it
 * under the terms of the GNU Lesser General Public License as
 * published by the Free Software Foundation; either version 2.1 of
 * the License, or (at your option) any later version.
 *
 * This software is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU
 * Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public
 * License along with this software; if not, write to the Free
 * Software Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA
 * 02110-1301 USA, or see the FSF site: http://www.fsf.org.
 */

RichFaces.QUnit.run(function() {
    module("richfaces-accordion");

    var ACCORDION_ID = "f:panel";

    test("RichFaces.ui.Accordion test constructor", function () {
        var c = RichFaces.$(ACCORDION_ID);

        ok(c instanceof RichFaces.ui.Accordion, "inctance of RichFaces.ui.Accordion");
        equals(c.id, ACCORDION_ID, "id");

        equals(c.getItems().length, 3, "getItems().length");
    });

    test("RichFaces.ui.Accordion test public api", function () {
        var c = RichFaces.$(ACCORDION_ID);

        var PUBLIC_API = [/* ... */];

        for (i in PUBLIC_API) {
            var funcName = PUBLIC_API[i];
            ok(c[funcName], funcName + "present in component")
            // TODO check other functions + check is it function
        }
    });

    test("RichFaces.ui.Accordion test events", function () {

    });
});
